---
layout: development
title: Window.js | Build
---

Build
=====

Window.js can be built after [checking out the sources](/dev/checkout) and
setting up the build environment.

The build involves five steps:

1.  Building ANGLE
2.  Building Skia
3.  Building v8
4.  Configuring the Window.js build
5.  Building Window.js


1 Building ANGLE
----------------

**Windows**

```
$ libraries\build_angle.bat
```

**Linux and macOS**

```
$ ./libraries/build_angle.sh
```


2 Building Skia
---------------

**Windows**

```
$ libraries\build_skia.bat
```

**Linux and macOS**

```
$ ./libraries/build_skia.sh
```


3 Building v8
-------------

**Windows**

```
$ libraries\build_v8.bat
```

**Linux and macOS**

```
$ ./libraries/build_v8.sh
```


4 Configuring Window.js
-----------------------

Run this once to set up the build directory, *`out`*:

```shell
$ cmake -S. -B out -DCMAKE_BUILD_TYPE=Release -G Ninja
```


5 Building Window.js
--------------------

This is the main build command, to build Window.js and rebuild again after code
modifications:

```shell
$ cmake --build out
```


Running Window.js
-----------------

Try running some of the examples once the build is finished:

```shell
$ out/windowjs examples/breakout.js
```
